#include <stdio.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include <stdlib.h>
#define F_CPU 16000000
#include <util/delay.h>
#define LETTER_WIDTH 5

char text_de_afisat[20];
int textLen = 10;



const int simboluri[][5] =
{
{0x00,0x00,0x6f,0x00,0x00},   // ! 0x21 33 1
{0x00,0x07,0x00,0x07,0x00},   // " 0x22 34 2
{0x14,0x7f,0x14,0x7f,0x14},   // # 0x23 35 3
{0x00,0x07,0x04,0x1e,0x00},   // $ 0x24 36 4
{0x23,0x13,0x08,0x64,0x62},   // % 0x25 37 5
{0x36,0x49,0x56,0x20,0x50},   // & 0x26 38 6
{0x00,0x00,0x07,0x00,0x00},   // ' 0x27 39 7
{0x00,0x1c,0x22,0x41,0x00},   // ( 0x28 40 8
{0x00,0x41,0x22,0x1c,0x00},   // ) 0x29 41 9
{0x14,0x08,0x3e,0x08,0x14},   // * 0x2a 42 10
{0x08,0x08,0x3e,0x08,0x08},   // + 0x2b 43 11
{0x00,0x50,0x30,0x00,0x00},   // , 0x2c 44 12
{0x08,0x08,0x08,0x08,0x08},   // - 0x2d 45 13
{0x00,0x60,0x60,0x00,0x00},   // . 0x2e 46 14
{0x20,0x10,0x08,0x04,0x02},   // / 0x2f 47 15
{0x3e,0x51,0x49,0x45,0x3e},   // 0 0x30 48 16
{0x00,0x42,0x7f,0x40,0x00},   // 1 0x31 49 17
{0x42,0x61,0x51,0x49,0x46},   // 2 0x32 50 18
{0x21,0x41,0x45,0x4b,0x31},   // 3 0x33 51 19
{0x18,0x14,0x12,0x7f,0x10},   // 4 0x34 52 20
{0x27,0x45,0x45,0x45,0x39},   // 5 0x35 53 21
{0x3c,0x4a,0x49,0x49,0x30},   // 6 0x36 54 22
{0x01,0x71,0x09,0x05,0x03},   // 7 0x37 55 23
{0x36,0x49,0x49,0x49,0x36},   // 8 0x38 56 24
{0x06,0x49,0x49,0x29,0x1e},   // 9 0x39 57 25
{0x00,0x36,0x36,0x00,0x00},   // : 0x3a 58 26
{0x00,0x56,0x36,0x00,0x00},   // ; 0x3b 59 27
{0x08,0x14,0x22,0x41,0x00},   // < 0x3c 60 28
{0x14,0x14,0x14,0x14,0x14},   // = 0x3d 61 29
{0x00,0x41,0x22,0x14,0x08},   // > 0x3e 62 30
{0x02,0x01,0x51,0x09,0x06},   // ? 0x3f 63 31
{0x3e,0x41,0x5d,0x49,0x4e},   // @ 0x40 64 32
};

volatile unsigned char text[512];
volatile unsigned int arrLen = 0;
volatile unsigned int arrIx = 0;

void construire_text();
void setare();
void initTimer();

void ADC_init(void)
{
	/* configure and enable ADC */
	ADCSRA|=(1 << ADEN);
	ADCSRA|=(1 << ADATE);
	ADCSRA|=(1<<ADPS2);
	ADCSRA|=(1<<ADPS1);
	ADCSRA|=(1<<ADPS0);
	ADMUX|=(1<<REFS0);
}

int ADC_get(uint8_t channel)
{

	ADMUX &= 0xE0;
	ADMUX |= channel;
	
	/* incep conversia si astept rezultatul; */
	ADCSRA |= (1 << ADSC);
	while (!(ADCSRA & (1<< ADIF)));
	
	return ADC;
}


int main(){
	int temperatura = 0;
	float aux;
	sei();
	arrLen = 0;
	DDRC = 255;
	
	ADC_init();
	temperatura =(int)(500*ADC_get(0)/1024);

	itoa(temperatura,text_de_afisat,10);

	construire_text();
	initTimer();
	while(1){
	}
	return 0;
}
void construire_text(void){
	unsigned int i, j;
	for(i = 0; i < textLen; i++)
	{
		for(j = 0; j < LETTER_WIDTH ; j++)
		{
			text[arrLen] = simboluri[text_de_afisat[i] - 32][j];
			arrLen = arrLen + 1;
		}
		for(j = 0; j < LETTER_WIDTH ; j++)
		{
			text[arrLen] = 0;
			arrLen = arrLen + 1;
		}
	}
	for(i = 0; i < textLen; i++)
	{
		for(j = 0; j < LETTER_WIDTH; j++)
		{
			text[arrLen] = 0;
			arrLen = arrLen + 1;
		}
	}
}
void setare(void)
{
	if(arrIx < arrLen)
	{
		PORTC =255 ^ text[arrIx++];
	} 
	else 
	{
		arrIx = 0;
	}
}
ISR(SIG_OUTPUT_COMPARE1A)
{
	setare();
}

void initTimer()
{
	// initializeaza timer pentru intreruperi la intervale de 0.01s
	OCR1A = 12;
	TCCR1A = 0;
	TCCR1B = (1<<WGM12)|_BV(CS12) | _BV(CS10);
	TIMSK |= _BV(OCIE1A);
}